.nolist             
   #include "ion.inc" 
   #include "Tasten.inc"
   #include "Zusatz.inc"
   
;_____________Definitionen:_________________________
#ifdef TI83P
#define HMax 7E90h
#else
#define HMax 7FFFh					;Maximalwerte fr Highscores
#endif

;_____________RAM-Variablen:________________________
#define EZahl		sram	;Wort
#define ZKoord		sram+2	;Wort
#define TVal		sram+4	;Wort
#define Zahl1		sram+6	;Wort
#define Zahl2		sram+8	;Wort
#define Ergebnis	sram+10	;Wort ]
#define NErgebnis	sram+12	;Wort ]
#define MaxAdd		sram+14	;Wort
#define MaxSub		sram+16 ;Wort
#define MaxMult		sram+18 ;Wort
#define MaxDiv		sram+20 ;Wort
#define Zaehler		sram+22	;]
#define AufgZahl	sram+23	;]
#define VZWort		sram+24 ;Wort
#define ZIndex		sram+26
#define Fehler		sram+27
#define HSAdresse	sram+28 ;Wort
#define Typwert		sram+30
#define TIndex		sram+31
#define TAdresse	sram+32 ;Wort
#define Ergebnis	sram+34 ;Wort
#define Shiftwert	sram+36
#define MIndex		sram+37
;sram+142=letzte Variable vor Bereich, der von Interrupt genutzt wird
;________________________________________________________________________________________________

.list                
#ifdef TI83P            
   .org  progstart-2    
   .db   $BB,$6D       
#else                   
   .org  progstart  
#endif
 
   ret             
   jr    nc,start     
   .db   "Ephalon 1.0",0
start:
 set textwrite, (iy+sgrflags)		;Text nur in den Bildschirmspeicher schreiben
 res plotloc,(iy+plotflags)
 
 bcall(_grbufclr)
 ld a,20							;Splash-Screen
 ld l,4
 ld bc,256*11+7
 ld ix,PSchrift
 call ionlargesprite
 ld a,32
 ld l,24
 ld bc,256*22+4
 ld ix,PGehirn
 call ionlargesprite
 ld hl,SASplash						;Strings anzeigen
 call vPutSArray 
 call ionfastcopy
Warten:
 bcall(_getCSC)
 or a
 jr z,Warten
 
HMenu:
 scf								;groes Rechteck fr Rahmen
 call Rahmen
 ld hl,SAHMenu
 call vPutSArray
 ld hl,SHilfe
 bcall(_vPutS)
 ld bc,256*25+52
 ld d,71
 call Unterstrich
 call ionfastcopy
 xor a								;Standard-Meneintrag
 ld (MIndex),a
 ld l,15							;Balkenkoordinate fr ersten Eintrag
 call ZeichneBalken
 
MSchleife:
 push hl							;Balkenkoordinaten sichern
 bcall(_getCSC)
 pop hl
 cp sk2nd
 jp z,Spiel_ausgewaehlt
 cp skAlpha
 jp z,Hilfe
 cp skDel
 jp z,Ende
 cp skOben
 jr z,NachOben
 cp skUnten
 jr nz,MSchleife
 
NachUnten:
 ld a,(MIndex)
 cp 4
 jr z,MSchleife
 inc a
 ld (MIndex),a						;Index erhhen, sofern noch nicht beim letzten Eintrag
 call ZeichneBalken					;alten Balken lschen
 ld a,l
 add a,7							;Balkenkoordinate erhhen
 ld l,a
 call ZeichneBalken
 jr MSchleife
 
NachOben:
 ld a,(MIndex)
 or a
 jr z,MSchleife
 dec a
 ld (MIndex),a						;Index erhhen, sofern noch nicht beim ersten Eintrag
 call ZeichneBalken					;alten Balken lschen
 ld a,l
 sub 7								;Balkenkoordinate verringern
 ld l,a
 call ZeichneBalken					;alten Balken lschen
 jr MSchleife
 
ZeichneBalken:
 ld a,13
 ld ix,PAnfang
 call PutSegment					;abgerundeter Anfang, l enthlt Y-Koordinate
 ld b,53
Mitte:
 inc a
 ld ix,PBalken
 push bc
 call PutSegment					;eigentlicher Balken
 pop bc
 djnz Mitte
 add a,8
 ld ix,PEnde
 call PutSegment
 push hl
 call ionfastcopy
 pop hl
 ret
PutSegment:
 push hl
 push af
 ld b,7
 call ionputsprite
 pop af
 pop hl
 ret
 
Hilfe:
 scf
 call Rahmen						;groer Rahmen
 ld a,(MIndex)
 cp 3
 jr z,HilfeD
 cp 4
 jr z,HilfeE						;je nach ausgewhltem Meneintrag entsprechende Hilfeseite anzeigen
HilfeABC:
 ld hl,SAHilfeABC
 jr DispHilfe
HilfeD:
 ld hl,SAHilfeD
 jr DispHilfe
HilfeE:
 ld hl,SAHilfeE
 jr DispHilfe
DispHilfe:
 call vPutSArray
 call ionfastcopy
 call Pause2nd
 jp HMenu
 
Spiel_ausgewaehlt:
 ld a,(MIndex)
 or a
 jr z,SpielA
 cp 1
 jr z,SpielB
 cp 2
 jr z,SpielC
 cp 3
 jr z,SpielD
 jr SpielE
;______________________________________________________________________________________________ 
SpielA:								;Add, Sub, Mult & Div von Zahlen <11 
 ld hl, 256*11+11
 ld (MaxAdd), hl					;Maxima fr Zahlen setzen
 ld (MaxSub), hl
 ld (MaxMult), hl
 ld (MaxDiv), hl
 ld hl, HA							;Spieltyp fr SpielA
 call Spielanfang
 jp nz, HMenu
 jp StartAB

;______________________________________________________________________________________________ 
SpielB:
 ld hl, 256*101+101					;Addition: Zahlen < 101
 ld (MaxAdd), hl
 ld hl, 256*201+201					;Subtraktion: Zahlen <200
 ld (MaxSub), hl
 ld hl, 256*11+21					;Multiplikation: Zahl1<11; Zahl2 <21
 ld (MaxMult), hl
 ld h, 101					;Division: Zahl1 <101; Zahl2<21
 ld (MaxDiv), hl
 ld hl, HB							;Spieltyp fr SpielB
 call Spielanfang
 jp nz, HMenu
 jp StartAB
 
;______________________________________________________________________________________________ 
SpielC:								;Quadratzahlen von x< 21
 ld hl,HC							;Spieltyp fr SpielC
 call Spielanfang
 jp nz, HMenu
 call CreateC
 call StartTimer
 jp CNeu
 
;______________________________________________________________________________________________ 
SpielD:								;Reaktionstraining
 ld hl,HD							;Spieltyp fr SpielD
 call Spielanfang
 jp nz,HMenu
 
 ld bc,256*32+15
 ld de,256*64+47					;Umrahmung
 call Rechteck
 ld bc,256*32+26
 ld de,256*64+36					;Querstriche
 call Rechteck
 ld bc,256*43+15
 ld de,256*53+47					;Lngsstriche
 call Rechteck
 call StartTimer
 jp SpielDSchleife
 
;______________________________________________________________________________________________ 
SpielE:								;Konzentrationstraining
 ld hl,HE
 call Spielanfang
 jp nz,HMenu
 call CreateE
 call StartTimer
 jp ENeu
 
;______________________________________________________________________________________________ 
StartAB:
 call CreateAB						;erste Aufgabe erstellen
 call StartTimer
 jr ABNeu

SpielABSchleife:
 call Zahleingabe					;Eingabefeld aufrufen
 jp nz, HMenu
 call Eingabe_prfen				;Aufgabe auswerten
 call Fortschrittsbalken
 jp z, Spielende					;Wenn genug Aufgaben gelst wurden, nicht mehr weitermachen
ABNeu:
 call Scrollen
 ld a, (Zaehler)
 cp 1								;Wenn nur noch 1 Aufgabe vorhanden, keine neue mehr erstellen
 jr z, SpielABSchleife
 call CreateAB						;sonst neue erstellen
 jr SpielABSchleife

 
CreateAB:							;Aufgabe erstellen und anzeigen
 ld b, 4
 call ionRandom						;Zufallszahl mit 4 mglichen Werten fr jede Grundrechenart
 call Aufgabe_erstellen				;zufllige Rechenaufgabe
 push af							;Wert des Rechenzeichens sichern
 ld a, 44
 ld (penrow), a						;Y-Koordinate
 ld hl, (Zahl1)
 call CheckZahl
 cp 2
 jr nz, ABKl100
 ld a, 23							;X-Koordinate fr Zahlen >99
 jr SetABPencol
ABKl100:
 cp 1
 jr nz, ABKl10
 ld a, 27							;das gleiche fr Zahlen <100
 jr SetABPencol
ABKl10:
 ld a, 31							;und Zahlen <10
SetABPencol:
 ld (pencol), a
 call DispVhl						;erste Zahl anzeigen
 ld a, 36
 ld (pencol), a
 pop af								;Rechenzeichen wiederherstellen
 bcall(_vPutMap)					;und anzeigen
 ld a, 41
 ld (pencol), a						;zweite Zahl anzeigen
 ld hl, (Zahl2)
 call DispVhl
 ld a, 53
 ld (pencol), a
 ld a, 3dh							;"="
 bcall(_vPutMap)
 ret
 
 
;______________________________________________________________________________________________  
SpielCSchleife:
 call Zahleingabe					;Eingabefeld aufrufen
 jp nz, HMenu
 call Eingabe_prfen
 call Fortschrittsbalken
 jp z, Spielende
CNeu:
 call Scrollen
 ld a, (Zaehler)
 cp 1
 jr z, SpielCSchleife
 call CreateC
 jr SpielCSchleife

CreateC:
 ld a, 4							;immer Quadratzahlen-Aufgabe erstellen
 call Aufgabe_erstellen
 ld a, 44							;Y-Koordinate
 ld (penrow), a
 ld b, 2
 call ionRandom						;je nach Zufall Quadratzahl oder -wurzelaufgabe stellen
 push af							;Aufgabentyp sichern
 or a
 ld hl, (Zahl1)
 jr nz, SetCPencol					;bei Quadratzahlaufgabe fortfahren
 ;Wurzel:
 ld de, (NErgebnis)
 ex de, hl
 ld (Zahl1), hl						;bei Wurzelaufgabe: Ergebnis und Zahl1 vertauschen
 ld (NErgebnis), de
 
SetCPencol:
 call CheckZahl
 cp 2
 jr nz, CKl100
 ld a, 33							;X-Koordinate fr Zahlen>99
 jr DispCZahl
CKl100:
 cp 1								
 jr nz, CKl10
 ld a, 37							;fr Zahlen <100
 jr DispCZahl
CKl10:
 ld a, 41							;und Zahlen <10
DispCZahl:
 ld (pencol), a						;X-Koordinaze speichern
 pop af								;Aufgabentyp wiederherstellen
 or a
 jr z, Wurzel
 call DispVhl						;Zahl anzeigen
 ld hl, pencol
 dec (hl)							;Koordinate anpassen
 ld a,12h
 bcall(_vPutMap)					;""
 jr DispGleich
Wurzel:
 ld a, 10h							;Wurzelzeichen
 bcall(_vPutMap)
 call DispVhl						;Zahl anzeigen

DispGleich:
 ld a, 53
 ld (pencol), a
 ld a, 3dh							;"="
 bcall(_vPutMap)
 ret

;______________________________________________________________________________________________ 
SpielDSchleife:
 ld b,9								;Zufallszahl fr Zelle erzeugen
 call ionrandom
 inc a								;Null verhindern
 ld (Ergebnis),a
 call DZeichnen
DEingabe:
 bcall(_getCSC)
 cp skDel
 jp z,HMenu
 cp skMode
 call z,Pause
 ld hl, Codes+9						;hl: Codeliste
 ld bc, 9							;bc= Anzahl der Versuche (Zahlen von 1-9)
 cpdr								;Vergleichen
 jr nz, DEingabe					;wenn keine Zifferntaste gedrckt, neu beginnen
 inc bc								;Zahl richtigstellen
 ld (EZahl),bc
 ld hl,plotsscreen+345
 ld bc,256*8+2
 call ClrRechteck					;Bereich des Richtig/Falsch-Sprites lschen
 ld bc,256*9+8
 ld de,256*87+54
 call Rechteck						;abgeschnittenen Rahmen reparieren
 call Eingabe_prfen
 call Fortschrittsbalken
 push af
 call fastcopy
 pop af
 jp z,Spielende						;Wenn genug Aufgaben gelst wurden, nicht mehr weitermachen
 ld a,(Ergebnis)
 call DZeichnen 					;altes Ziel lschen
 jr SpielDSchleife
 
DZeichnen:
 cp 4
 jp p,VierBis6
 ld l,39							;Y-Koordinate fr entsprechende Zeile
 jr SetSpalte
VierBis6:
 cp 7
 jp p,SiebenBis9
 ld l,28
 sub 3								;Zahl auf Bereich von 1-3  angleichen
 jr SetSpalte
SiebenBis9:
 ld l,17
 sub 6
SetSpalte:
 cp 1
 jr nz, Spalte23
 ld a,33							;X-Koordinate fr entsprechende Spalte
 jr ZeichneZiel
Spalte23:
 cp 2
 jr nz, Spalte3
 ld a,44
 jr ZeichneZiel
Spalte3:
 ld a,55
ZeichneZiel:
 ld b,8
 ld ix,PZiel
 call ionputsprite					;Ziel an entsprechender Position anzeigen
 call fastcopy
 ret
;______________________________________________________________________________________________ 
SpielESchleife:
 call fastcopy
 bcall(_getCSC)
 cp skMode
 call z,Pause
 cp skDel
 jp z,HMenu
 cp sk2nd
 jr nz,CheckAlpha
 xor a								;0= anderer Buchstabe bzw. falsche Punktzahl
 ld ix,PNein
 jr EAuswertung					
CheckAlpha:
 cp skAlpha
 jr nz,SpielESchleife
 ld a,1								;1= d mit 2 Punkten
 ld ix,PJa
EAuswertung:
 ld (EZahl),a
 ld a,48
 ld l,33
 ld b,3
 call ionputsprite					;je nach Antwort Symbol in Kstchen setzen
 call Eingabe_prfen
 call Fortschrittsbalken
 jp z,Spielende
ENeu:
 call Scrollen
 ld a,(Zaehler)
 cp 1
 jr z,SpielESchleife
 call CreateE
 jr SpielESchleife
 
CreateE:
 xor a
 ld (NErgebnis),a					;Ergebnis zurcksetzen
 ld b,4
 call ionrandom						;Zahl der Punkte bestimmen
 or a
 jr z,Buchstabe						;bei 0 keinen Punkt anzeigen
 cp 1
 jr z,EinPunkt						;bei 1 einen Punkt anzeigen
 ld a,1								;sonst 2 Punkte anzeigen
 ld (NErgebnis),a					;Ergebnis auf "halb richtig" setzen
ZweiPunkte:
 ld ix,PZweiPunkte
 jr DispPunkte
EinPunkt:
 ld ix,PEinPunkt
DispPunkte:
 ld a,35
 ld l,42
 ld b,2
 call ionputsprite					;Punkte anzeigen
 
Buchstabe:
 ld b,10
 call ionrandom						;Art des Buchstabens bestimmen
 or a
 jr z,BuchB
 cp 1
 jr z,BuchQ 
 cp 2
 jr z,BuchP							;je nach Zahl Buchstaben whlen
 ld ix,PBuchD						;d (kommt hufiger vor)
 ld a,(NErgebnis)
 or a
 jr nz,DispBuchstabe				;Ergebnis auf 1 lassen, wenn D ausgewhlt wurde
 jr ResErgebnis						;sonst auf 0 setzen
 
BuchB:
 ld ix,PBuchB
 jr ResErgebnis
BuchQ:
 ld ix,PBuchQ
 jr ResErgebnis
BuchP:
 ld ix,PBuchP
ResErgebnis:
 xor a
 ld (NErgebnis),a					;Ergebnis auf 0 setzen

DispBuchstabe:
 ld a,35
 ld l,45
 ld b,9
 call ionputsprite					;Buchstabe anzeigen
 ld a,48
 ld l,46
 ld b,7
 ld ix,PCheckbox					;Kstchen anzeigen
 call ionputsprite
 ret
;______________________________________________________________________________________________ 
Ende:
 im 1								;eventuell laufenden Timer stoppen
 res textwrite, (iy+sgrflags) 
 ret
 
 
 
 
 
 
 
 
 
 
 
 
 
 

 
 
 
 
;______________________________________________________________________________________________
;____________   Routinen:__________________________________________________________________________
;______________________________________________________________________________________________

;______________________________________________________________________________________________
Aufgabe_erstellen:	;(Eingabe: a= Rechenart. Ausgabe:  (Zahl1) und (Zahl2): Operanden; (NErgebnis) = Ergebnis der Rechnung; a= Rechenzeichen. Zerstrt: af, hl, de, bc)
Check1:
 or a								;wenn a=0, addieren
 jr nz, Check2
 ld bc, (MaxAdd)
 call SetZahlen						;Zufallszahlen im angegebenen Bereich erzeugen
 ld hl, (Zahl1)
 ld de, (Zahl2)
 add hl, de
 ld (NErgebnis), hl
 ld a, 2bh							;+-Operand auf a laden
 ret
Check2:
 cp 1								;Wenn a=1, subtrahieren
 jr nz, Check3
Subtr:
 ld bc, (MaxSub)
 call SetZahlen
 ld de, (Zahl2)
 ld hl, (Zahl1)
 and a								;Carry resetten
 sbc hl, de
 jp p, SValid						;Wenn Differenz >0, als gltiges Ergebnis speichern, sonst wiederholen
 jr Subtr
SValid:
 ld (NErgebnis), hl
 ld a, 2dh 							;"-"
 ret
Check3:
 cp 2								;wenn a=2, multiplizieren
 jr nz, Check4
 ld bc, (MaxMult)
 call SetZahlen
 ld hl, (Zahl1)
 ld a, (Zahl2)
 call HLmalA
 ld (NErgebnis), hl
 ld a, 09h							;"*"
 ret
Check4:
 cp 3								;wenn a=3, dividieren
 jr nz, Check5
Divid:
 ld bc, (MaxDiv)
 call SetZahlen
 ld hl, (Zahl1)						
 ld de, (Zahl2)
 ld a, e
 or a
 jr z, Divid						;wenn zweite Zahl=0, neuer Versuch
 call HLdurchDE
 jp p, DValid						;wenn Division restlos ist, als gltiges Ergebnis abspeichern, sonst wiederholen
 jr z, DValid
 jr Divid
DValid:
 ld (NErgebnis), hl
 ld a, 2fh 							; "/"
 ret
Check5:								;Wenn a=4, Quadrat von Zahl1 bilden
 ld bc, 256*21+1
 call SetZahlen
 ld hl, (Zahl1)
 ld a, (Zahl1)
 call HlmalA
 ld (NErgebnis), hl
 ret
 
 
;________________________________________________________________________________________________ 
DispScores:	;(zeigt Highscores fr ein Spiel an. Eingabe: HSAdresse: gewnschte Highscores. Zerstrt: af,bc,de,hl)
 and a								;kleines Rechteck
 call Rahmen
 ld hl,256*10+30
 ld (pencol),hl
 ld hl,SBListe
 bcall(_vPutS)
 ld bc,256*29+46
 ld d,66
 call Unterstrich
 ld hl,(HSAdresse)
 ld bc,20
 add hl,bc							;Adresse+20=Platz 1 der HS-Eintrge
 ld a,3								;Schleifenzhler
 ld ix,256*23+20					;Koordinaten
DispSchleife
 push af
 push ix							;Koordinaten sichern
 push hl							;Adresse sichern
 call ld_BCvonHL					;HS-Wert laden
 push bc							
 pop hl								;HS-Wert auf hl laden
 call DispZeitMS
 pop hl								;Adresse wiederherstellen
 push hl							;und nochmals sichern
 inc hl
 inc hl								;auf zugehmrigen String zeigem
 ld b,8
 bcall(_vPutSN)
 pop hl
 ld bc,10
 and a								;Carry resetten
 sbc hl,bc							;auf niederen Eintrag zeigen
 pop ix								;Koordinaten wiederherstellen
 ld bc,256*8
 add ix,bc							;Koordinatenwert anpassen
 pop af
 dec a
 jr nz, DispSchleife
 call ionfastcopy
 ret
 
;________________________________________________________________________________________________
Kreis:	;(zeigt die Kreisanimation vor Spielbeginn an.)
 and a								;kleines Rechteck
 call Rahmen						;Rahmen neu zeichnen
 ld hl,256*18+36
 ld (pencol),hl
 ld hl, SBereit
 bcall(_vPutS)
 ld ix,P3							;erste Grafik
DispKreis:
 ld a,40							;X-Koordinate
 ld l,28							;Y-Koordinate
 ld bc,256*16+2						;256*Hhe+Breite
 call PutKreis
 ld a,48
 ld l,29
 ld bc,256*11+1
 call PutKreis
 ld a,43
 ld l,35
 ld bc,256*8+2
 call PutKreis
 ld a,41
 ld l,29
 ld bc,256*11+1
PutKreis:
 call ionlargesprite
 push ix							;Sprite sichern
 call ionfastcopy
 ld hl,55000
 call Verz
 pop ix
 ret

;______________________________________________________________________________________________
Spielanfang:
 push hl							;Highscoreadresse sichern
 and a								;kleines Rechteck
 call Rahmen
 ld hl, 256*20+20
 ld (pencol), hl
 ld hl, SAufgZahl
 bcall(_vPutS)
 call ionfastcopy
 ld a, 25							;Standard-Aufgabenzahl
 ld b, 0							;Standard-Additionswert
 jr DispAZahl
ASchleife:							;Tasteneingaben
 bcall(_getCSC)
 cp skLinks
 jr z, ALinks
 cp skRechts
 jr z, ARechts
 cp sk2nd
 jr z, StarteSpiel
 cp skDel
 jr z, AAbort
 jr ASchleife
 
ALinks:
 ld a, (Zaehler)
 cp 100								;wenn Wert=100, auf 50 setzen
 jr z, Set50
 cp 50								;bei Wert=50 ->25
 jr z, Set25
 jr Set100							;bei Wert=25 ->100
 jr DispAZahl
 
ARechts:
 ld a, (Zaehler)
 cp 25
 jr z, Set50
 cp 50
 jr z, Set100
Set25:
 ld a, 25
 ld b, 0							;Wert, der auf Spieltyp addiert werden muss
 jr DispAZahl
Set50:
 ld a, 50
 ld b, 30
 jr DispAZahl
Set100:
 ld a, 100
 ld b, 60
DispAZahl:
 ld (Zaehler), a					;Zhlerwert sichern
 ld (AufgZahl),a					;Kopie fr Fortschrittsbalken speichern
 ld l, a
 ld h, 0							;und zustzlich auf hl laden
 ld a, b
 ld (Typwert), a					;Additionswert sichern
 bcall(_setXXXXOP2)
 bcall(_OP2toOP1)					;in OP1 speichern zum Anzeigen
 ld hl, plotsscreen+427
 ld bc,256*6+1
 call ClrRechteck					;eventuell briggebliebenen Pfeil lschen					
 ld hl, 256*35+38
 ld (pencol), hl
 ld a, 0CFh							;Pfeil links
 bcall(_vPutMap)
 ld a, 44
 ld (pencol), a						;Abstand nach Pfeil
 bcall(_dispop1a)					;Aufgabenzahl anzeigen
 ld a, 05h							;Pfeil rechts
 bcall(_vPutMap)
 call ionfastcopy
 jr ASchleife
AAbort:
 pop hl								;Stack richtigstellen
 inc a
 ret
StarteSpiel:
 pop hl								;HS-Adresse wiederherstellen
 ld bc, (Typwert)					;Additionswert zu Highscoreadresse dazuaddieren
 ld b,0
 add  hl,bc
 ld (HSAdresse),hl
 xor a
 ld (Ergebnis+1),a					;Ergebnis-HiByte zurcksetzen
 ld (EZahl+1),a
 ld (NErgebnis+1),a
 ld (Fehler), a						;Fehlerzhler auf 0 setzen
 call Kreis
 and a								;kleines Rechteck
 call Rahmen						;Rahmen anzeigen
 ld hl,plotsscreen+697
 ld bc,256*4+10
 call ClrRechteck					;Bereich fr Fortschrittsbalken freimachen
 ld bc,256*9+1
 ld de,256*87+5
 call Rechteck						;Umrahmungslinien fr Balken
 call ionfastcopy
 ret
 
;_______________________________________________________________________________________________
Spielende:
 call ionfastcopy
 im 1								;Timer anhalten
 ld hl,40000
 call Verz
 and a								;kleines Rechteck
 call Rahmen
 ld hl,SAEnde
 call vPutSArray					;Texte anzeigen
 ld bc,256*37+46
 ld d,58
 call Unterstrich
 ld ix, 256*23+60
 ld hl, (TVal)
 push hl							;Timerwert sichern
 call DispZeitMS					;Zeit anzeigen
 ld hl,256*33+20
 ld (pencol),hl
 ld a,2bh
 bcall(_vPutMap)					;"+"
 ld a, (Fehler)						;Fehlerzahl anzeigen
 bcall(_setXXOP1)
 ld a,3
 bcall(_dispop1a)
 ld bc,256*24+22
 ld d,78
 call Unterstrich
CalcZeit:
 ld a, (Fehler)
#ifdef TI83P
 ld hl, 1080
#else
 ld hl, 1100
#endif
 call HLmalA						;fr jeden Fehler 10 Sekunden Zeitstrafe berechnen
 pop de								;Timerwert auf de laden
 jp pe, Ungueltig					;bei berlauf ungltige Zeit
 and a
 adc hl, de							;Zeit+Strafzeit addieren
 jp pe, Ungueltig
 ld (Ergebnis),hl					;Ergebnis speichern
ZeitAnzeigen:
 ld ix, 256*44+42
 call DispZeitMS					;Zeit mit Zeitstrafe anzeigen
 jr Gueltig
Ungueltig:
 ld hl, 256*44+39
 ld (pencol),hl
 ld hl, SUngueltig
 bcall(_vPutS)
 call ionfastcopy
 call Pause2nd
 jr HScores

Gueltig:
 call ionfastcopy					;Text der Auswertung und Blinken anzeigen
 ld ix, PBlink
 ld bc,256*9+3
 ld a,37
 ld l,43
 call ionlargesprite
 ld hl,10000
 call Verz
 bcall(_getCSC)
 cp sk2nd
 jr z,CheckScores					;bei 2nd Highscores prfen & anzeigen
 cp skDel
 jr nz,Gueltig						;bei Del beenden
 jp HMenu
 
CheckScores:
 ld hl, (HSAdresse)
 ld a,3								;insgesamt 3 Durchlufe der Einsetzschleife
Einsetzen:
 call ld_BCvonHL					;HS-Wert auf bc laden
 push hl							;Adresse sichern
 ld hl,(Ergebnis)
 and a								;Carry resetten
 sbc hl, bc							;Ergebnis mit HS-Wert vergleichen
 pop hl
 push hl
 pop de								;Adresse  sowohl auf de als auch auf hl wiederherstellen
 jp p, Namen						;Wenn Ergebnis > HS, beenden
 cp 3
 jr z,HSSpeichern					;bei Vergleich mit Eintrag 3 nicht verschieben, sondern berschreiben
 push hl							;Adresse nochmals sichern
 ld bc,10
 and a								;Carry resetten
 sbc hl,bc							;Startadresse zum Kopieren
 ex de,hl							;Startadresse auf hl,Zieladresse auf de
 ldir								;HS-Eintrag nach unten verschieben
 pop hl								;Adresse wiederherstellen
HSSpeichern:
 ld bc,(Ergebnis)
 call ld_BCaufHL					;Ergebnis speichern
 ld bc,10
 add hl,bc							;auf nchsten Eintrag zeigen
 dec a
 jr nz,Einsetzen
 
Namen:
 ld bc,10
 and a								;Carry resetten
 sbc hl,bc							;Adresse richtigstellen
 cp 3
 jr z,HScores						;bei a=3 wurde kein HS erreicht
 inc hl								;(Adresse ist auf hl)
 inc hl								;Zeiger fr Namenseintrag
 ex de,hl							;Zeiger auf de laden
 call Texteingabe
 jp nz,HMenu

HScores:
 call DispScores					;Highscoreliste anzeigen
 call Pause2nd
 jp nz,HMenu						;bei Del beenden
 jp HMenu
 
;______________________________________________________________________________________________
StartTimer:
 ld hl, 0
 ld (TVal), hl						;Zeitwert initialisieren
 di
#ifdef TI83P
 ld hl, 9900h						;Interrupt-Tabelle erstellen
 ld de, 9900h+1
 ld bc, 256
 ld (hl), 9ah
 ldir
 ld hl, interrupt_start
 ld de, 9a9ah
 ld bc, interrupt_ende-interrupt_start
 ldir								;Interruptroutine kopieren
 
 ld a, 99h
#else								;bei Ti83 ist der sicherere RAM-Bereich nicht vorhanden, stattdessen wird der APD-RAM verwendet
 ld hl, 8300h
 ld de, 8300h+1
 ld bc, 256
 ld (hl), 84h
 ldir
 ld hl, interrupt_start
 ld de, 8484h
 ld bc, interrupt_ende-interrupt_start
 ldir
 
 ld a, 83h
#endif

 ld i, a
 im 2								;Interrupt starten
 ei
 ret
 
;________________________________________________________________________________________________
Texteingabe:	;(Eingabe eines 8 Zeichen langen HS-Namens. Eingabe: de:Adresse)
 push de
 inc a
 bcall(_setXXOP1)					;Platznummer sichern
 and a								;kleines Rechteck
 call Rahmen
 ld hl,256*17+34
 ld (pencol),hl
 ld a,1
 bcall(_dispop1a)					;Platznummer anzeigen
 ld hl,SATexteingabe
 call vPutSArray
 ld bc,256*31+20
 ld de,256*64+27
 call Rechteck
 ld ix,PShiftOn
 call DispShift
 pop de
 ld (TAdresse),de					;Adresse speichern
 ld a,8
 ld (TIndex),a						;maximal 8 Zeichen
 xor a
 ld (Shiftwert),a					;kein Shift
 jr Loeschen						;zunchst gesamten String lschen
TSchleife:
 bcall(_getCSC)
 cp skLinks							;bei [<-] letztes Zeichen lschen
 jr z, TRueck
 cp skClear							;bei [Clear] ganzen Text lschen
 jr nz, TNLoeschen
Loeschen:
 ld b,8
 ld a,20h
 ld hl,(TAdresse)
ClrSchleife:
 ld (hl),a							;alle 8 Zeichen auf 0 setzen
 inc hl
 djnz ClrSchleife
 ld a,8
 ld (TIndex),a						;Zhler zurcksetzen
 ld de,(TAdresse)					;Zeiger zurcksetzen
 jr DispText
TNLoeschen:
 cp skDel
 jr z, TAbort						;bei [Del] Programm abbrechen
 cp skAlpha							;bei [Graph] Shift aktivieren
 jr z,Shift
 cp sk2nd							;bei [2nd] ist Eingabe abgeschlossen
 ret z
 ld hl,Tasten+25
 ld bc,26
 cpdr								;der gedrckten Taste eine Zahl zwischen 0 und 25 zuweisen
 jr nz,TSchleife					;wenn keine Buchstabentaste gedrckt wurde, auf neuen Tastendruck warten
 ld a,(TIndex)
 or a
 jr z,TSchleife						;wenn schon 8 Zeichen eingegeben wurden, keine neuen zulassen
 ld hl,65
 add hl,bc							;Zahl+Codewert von "A" = gedrckter Buchstabe
 ld a,(Shiftwert)
 add a,l							;Wert addieren, der Gro-oder-Kleinschreibung entscheidet
 ld (de),a
 inc de
 ld hl,TIndex
 dec (hl)
DispText:
 push de
 ld hl,plotsscreen+448
 ld bc,256*5+4
 call clrRechteck
 ld hl,256*36+32
 ld (pencol),hl
 ld hl,(TAdresse)
 ld b,8
 bcall(_vPutSN)
 call ionfastcopy
 pop de
 jr TSchleife
TRueck:
 ld a,(TIndex)
 cp 8								;prfen, ob der Text lnger als 0 Zeichen ist
 jr z,TSchleife
 inc a
 ld (TIndex),a
 ld a,20h
 dec de								;Zeiger auf neues letztes Zeichen
 ld (de),a							;letztes Zeichen lschen
 jr DispText
Shift:
 call DispShift						;altes Symbol lschen
 ld a,(Shiftwert)
 or a
 jr z,ShiftOff						;wenn Shift abgeschaltet ist, aktivieren, sonst deaktivieren
 xor a
 ld ix,PShiftOn
 jr ShiftSpeichern
ShiftOff:
 ld a,20h
 ld ix,PShiftOff
ShiftSpeichern:
 ld (Shiftwert),a
 call DispShift
 jp TSchleife
TAbort:
 inc a							;z-Flag zurcksetzen
 ret
DispShift:
 push de
 ld a,53
 ld l,46
 ld bc,256*8+2
 push ix							;Sprite sichern
 call ionlargesprite				;Sprite anzeigen
 pop ix
 call ionfastcopy
 pop de
 ret

;______________________________________________________________________________________________
Zahleingabe:	;(Ausgabe: (EZahl) = eingegebene 16bit-Zahl. z-Flag  nicht gesetzt, wenn Programm abgebrochen werden soll. Zerstrt: af, de, hl, bc)
 call fastcopy
 ld hl, 0
 ld (EZahl), hl
 xor a
 ld (ZIndex), a						;ZIndex auf 0 setzen
ZSchleife:
 bcall(_getCSC)
 cp skClear							;bei [Clear] ganze Zahl lschen
 jr nz, NLoeschen
 ld hl, 0
 ld (EZahl), hl
 xor a
 ld (ZIndex), a						;ZIndex auf 0 setzen
 jr DispZ
NLoeschen:
 cp skDel
 jr z, Abort						;bei [Del] Programm abbrechen
 cp skMode
 call z,Pause
 cp sk2nd							;bei [2nd] ist Eingabe abgeschlossen
 ret z
 ld hl, Codes+9						;hl: Codeliste
 ld bc, 10							;bc= Anzahl der Versuche
 cpdr								;Vergleichen
 jr nz, ZSchleife					;wenn keine Zifferntaste gedrckt, neu beginnen
 ld a, 3						
 ld d, a
 ld a, (ZIndex)
 cp d								;momentanen Zhler mit Maximalwert vergleichen ->wenn gleich gro, keine Eingabe mehr zulassen
 jr z, ZSchleife
 inc a								;ansonsten Zhler erhhen
 ld (ZIndex), a
 ld hl, (EZahl)
 ld a, 10							;Zahl mit 10 multiplizieren
 call HLmalA
 add hl, bc							;und neue Ziffer dazuaddieren
 ld (EZahl), hl
DispZ:
 ld hl, plotsscreen+367
 ld bc,256*5+2						;16*5-Rechteck lschen
 call clrRechteck
 ld hl, 256*29+58					;Ausgabe auf Bildschirm
 ld (pencol), hl
 ld hl, (EZahl)
 call DispVHl
 call fastcopy
 jr ZSchleife
Abort:
 inc a							;z-Flag zurcksetzen
 ret
 
 
;______________________________________________________________________________________________
;____________  Subroutinen:________________________________________________________________________
;______________________________________________________________________________________________
;________________________________________________________________________________________________
CheckZahl: ;(Eingabe: hl= zu prfende Zahl. Ausgabe: hl>99: a=2, hl>9: a=1, hl<10: a=0. Zerstrt: af, de)
 ld a, 2
 ld de, 100							
 push hl
 and a								;Carry resetten
 sbc hl, de
 pop hl
 ret p								;wenn Zahl >99, ohne Vernderung zurckkehren (a=2)
;ZKl100:
 dec a
 ld de, 10
 push hl
 and a								;Carry resetten
 sbc hl, de
 pop hl
 ret p								;wenn Zahl >9, a=1
 dec a								;sonst mit a=0 zurckkehren
 ret
 
;________________________________________________________________________________________________
ClrRechteck: ;(lscht ein b*c/8 groes Rechteck. Eingabe: hl=Beginn des Rechtecks (plotsscreen+X); b: Hhe; c:Breite (in Bytes). Zerstrt:af, b, hl
 ld de, 12
 ld a,e
 sub c								;Wert, der nach Lschen einer Zeile addiert werden muss, um zur nchsten zu kommen
 ld e,a
 xor a
ClrLoop1:
 push bc
ClrLoop2:
 ld (hl), a							;c Bytes pro Zeile auf 0 setzen
 inc hl
 dec c
 jr nz,ClrLoop2
 add hl, de							;nchste Zeile
 pop bc
 djnz ClrLoop1
 ret

;________________________________________________________________________________________________
Fortschrittsbalken:	;(zeichnet den Fortschrittsbalken)
 call DispBalken					;alten Balken lschen
 ld hl, Zaehler
 dec (hl)
 push af							;Flags sichern
 call DispBalken					;Balken anzeigen
 pop af 
 ret
DispBalken:
 ld hl, (Zaehler)					;Zaehler und AufgZahl laden
 ld a, h							;AufgZahl auf a laden
 sub l								;AufgZahl-Zaehler = Zahl der gelsten Aufgaben
 ld hl,79
 call HLmalA
 ld de, (AufgZahl)
 ld d,0
 call HLdurchDE						;Prozentsatz der gelsten Aufgaben in einen Bereich von 0-79 projizieren
 ld a,l								;X-Koordinate (Startwert)
Balken:
 cp 2
 ret m
 ld ix,PBalken
 ld l,58							;Y-Koordinate
 ld b,4								;Hhe
 push af
 call ionputsprite
 pop af
 dec a
 jr Balken

;______________________________________________________________________________________________
DispZeitMS:	;(Eingabe: hl= umzurechnende Zeit; ix=Koordinatenwert. Ausgabe: Zeit in Minuten:Sekunden wird angezeigt . Zerstrt: af, bc, de, hl)
 ld (pencol), ix
#ifdef TI83P
 ld de, 108
#else
 ld de, 110
#endif								;In Sekunden umrechnen
 call HLdurchDE
 push hl							;Gesantsekundenwert sichern
 ld de, 60							;In Minuten umrechnen
 call HLdurchDE
 push hl
 call DispVHl						;Minuten anzeigen
 pop hl
 ld a, 60
 call HLmalA						;wieder in Sekunden umrechnen ->durch Ganzzahldivision fallen brig gebliebene Sekunden weg
 pop de								;Gesamtsekundenwert wieder holen
 ex de, hl
 and a								;Carry
 sbc hl, de							;ganze Minuten von Sekunden abziehen
 ld a, (pencol)
 sub 2
 ld (pencol),a						;Koordinaten anpassen
 ld a, 3ah							;":"
 bcall(_vPutMap)
 ld a, 9
 cp l
 jp m, EStelle						;wenn Sekundenwert <10, eine Null nach dem Doppelpunkt anzeigen
 ld a,30h							;"0"
 bcall(_vPutMap)
EStelle:
 call DispVhl						;Sekunden anzeigen
 ret

;______________________________________________________________________________________________
DispVHL: ;(Eingabe:Koordinaten in (pencol), hl=auszugebende Zahl. Ausgabe: hl wird in kleiner Schrift angezeigt. Zerstrt: alle Register)
 bcall(_setXXXXOP2)
 bcall(_OP2toOP1)
 ld a, 4
 bcall(_dispop1a) 
 ret
 
;______________________________________________________________________________________________
Eingabe_prfen:	;(Eingabe: (EZahl)= eingegebene Zahl; (Ergebnis)= Ergebnis der Rechnung. Ausgabe: je nach Richtigkeit wird "R" oder "F" angezeigt. Zerstrt: alle Register)
 ld hl, (EZahl)
 ld de, (Ergebnis)
 and a								;Carry resetten
 sbc hl, de							;richtiges Ergebnis mit eingegebener Zahl vergleichen
 jr z, Richtig
 ld hl, Fehler						;Fehlerzhler erhhen
 inc (hl)
 ld ix, pFalsch
 jr DispRF
Richtig:
 ld ix, pRichtig
DispRF:
 ld a, 74
 ld l, 28
 ld b, 8
 call ionPutSprite					;Symbol, abhngig davon ob Zahl richtig oder falsch ist, anzeigen
 ret
 
;______________________________________________________________________________________________
FastCopy:	;(fhrt ionfastcopy aus und reaktiviert Interrupts)
 call ionfastcopy
 ei
 ret
;______________________________________________________________________________________________
HLmalA:		;(Eingabe: hl, a. Ausgabe: hl=hl*a. Zerstrt: af, hl, de)
 or a
 jr z, Null							;Wenn b=0, hl auf 0 setzen
 push hl
 pop de								;de auf hl laden
MLoop:
 dec a
 jr z, MEnde
 and a
 adc hl, de 
 jp pe,MEnde
 jr MLoop
Null:
 ld hl, 0
 inc a								;verhindern, dass das P/O-Flag auf ungltiges Ergebnis hinweisen wrde
MEnde:
 ret
 
;______________________________________________________________________________________________
HLdurchDE:	;(Eingabe: hl, de. Ausgabe: hl=hl/de. Wenn m, ist die Division nicht passend. Zerstrt: bc, de, hl)
 res 7, h							;verhindert, dass das hchste hl-Bit als Vorzeichen angesehen wird
 ld bc, 0
DLoop:
 and a								;Carry resetten
 sbc hl, de
 jp m, DEnde						;Wenn Ergebnis negativ, Division beenden
 inc bc
 jr nz, DLoop
DEnde:
 push bc
 pop hl								;bc auf hl laden
 ret
 
;________________________________________________________________________________________________
interrupt_start:	;(Interruptroutine fr Timer)
 push af							;Register sichern
 push hl
 ld hl, (TVal)						;Zeitwert laden
 inc hl								;und erhhen
 ld (TVal), hl
 pop hl
 pop af
 jp 38h								;zu Ti-Interrupts springen
interrupt_ende:

;________________________________________________________________________________________________
ld_BCvonHL:	;(ldt den Inhalt der Speicherzelle hl auf bc (Wort))
 ld c,(hl)
 inc hl
 ld b,(hl)
 dec hl
 ret
 
;________________________________________________________________________________________________
ld_BCaufHL:	;(ldt bc auf die Speicherzelle hl (Wort))
 ld (hl),c
 inc hl
 ld (hl),b
 dec hl
 ret
;________________________________________________________________________________________________
Pause: ;(schaltet den Rechner aus. Zerstrt: a)
 di									;Timer und sonstige Interrupts ausschalten
 ld a,1
 out (3),a							;Bildschirm ausschalten
 ei
 halt								;Verzgerung fr Tastatur
 ret

;________________________________________________________________________________________________
Pause2nd:	;(wartet auf Tastendruck von 2nd oder  Del. Ausgabe: z  wenn 2nd gedrckt, sonst nz. Zerstrt: af, hl, b)
 bcall(_getCSC)
 cp sk2nd
 ret z
 cp skDel
 jr nz, Pause2nd
 inc a								;z-Flag zurcksetzen
 ret
 
;________________________________________________________________________________________________
vPutSArray:	;(zeigt ein Stringarray (Sammlung von Strings und zugehrigen Koordinaten) an. Eingabe: hl=Adresse des Arrays. Zerstrt: hl,bc,af)
 ld b, (hl)							;Anzahl der Strings laden
 dec hl
vPutSchleife:
 push bc							;Zhler sichern
 inc hl
 inc hl
 call ld_BCvonHL					;Koordinaten auf bc laden
 ld (pencol),bc
 inc hl
 inc hl
 call ld_BCvonHL					;Stringadresse auf bc laden
 push hl
 push bc
 pop hl								;Stringadresse auf hl
 bcall(_vPutS)
 pop hl
 pop bc								;Zhler wiederherstellen
 djnz vPutSchleife
 ret
 
;________________________________________________________________________________________________ 
Rahmen:	;(zeichnet den Rahmen. Eingabe: C= groes Rechteck,NC=kleines R)
 push af							;Flags sichern
 bcall(_grbufclr)					;Bildschirm lschen
 ld l,56							;Y-Startwert
RYSchleife:
 ld a,88							;X-Startwert
RXSchleife:
 push af
 push hl
 ld ix, PRahmen
 ld b,8								;Hhe
 call ionPutSprite
 pop hl
 pop af
 sub 8								;X-Koord. anpassen
 jp p,RXSchleife
 ld a,l
 sub 8
 ld l,a
 jp p,RYSchleife
 
 ld hl,plotsscreen+97
 ld bc,256*48+10					;Werte fr kleines Rechteck
 pop af								;Flags wiederherstellen
 jp nc, Ausschneiden						
 ld hl,plotsscreen+25
 ld bc,256*59+10					;bei gesetztem Carry-Flag groes Rechteck ausschneiden
Ausschneiden:
 push af
 call clrRechteck					;Mitte aussschneiden
 pop af
 ld bc,256*9+8
 ld de,256*87+54					;Werte fr kleines Rechteck
 jp nc,Umrahmen
 ld c,2
 ld e,60
Umrahmen:
 call Rechteck						;umrahmen
 ret
;______________________________________________________________________________________________ 
Rechteck:	;(zeichnet ein Umrahmungsrechteck. Eingabe: bc: 256*X1+Y1; de:256*X2+Y2. Zerstrt: bc,de,h,f)
 ld h,1								;schwarze Linien
 push bc
 push bc							;ersten Punkt zweimal sichern
 push de							;zweiten Punkt sichern
 dec d								;Linie verkrzen, damit Rechteck runder wird
 ld e,c								;X1Y1 nach X2Y1
 bcall(_iLine)
 pop bc
 inc d
 inc e
 bcall(_iLine)
 pop de
 inc c
 ld e,c
 dec b
 bcall(_iLine)
 pop bc
 dec b
 inc c
 dec d
 dec e
 bcall(_iLine)
 ret
 
;______________________________________________________________________________________________ 
Scrollen:	;(scrollt den Bildschirminhalt whrend des Spiels um 15 Pixel nach oben)
 ld b, 15
ScrollLoop1:
 push bc
 ld hl, plotsscreen+121
 ld de, plotsscreen+109
 ld a, 45							;Hhe des Scrollbereiches
ScrollLoop2:
 ld bc,10
 ldir								;eine Zeile auf die vorige kopieren
 inc hl
 inc hl
 inc de							
 inc de
 dec a
 jr nz, ScrollLoop2
 pop bc
 dec b
 push af
 push bc
 call fastcopy
 pop bc
 pop af
 jr nz, ScrollLoop1
 ld hl, (NErgebnis)
 ld (Ergebnis),hl					;Ergebnis von nchster Aufgabe auf aktuelle kopieren
 ret
 
;_______________________________________________________________________________________________
SetZahlen:		;(Eingabe: c= max(Zahl2); b = max(Zahl1). Ausgabe: (Zahl1) und (Zahl2) =Zufallszahlen zwischen 0 und 9. Zerstrt: af, bc)
 call ionRandom						;erste Zufallszahl fr Rechenaufgabe
 ld (Zahl1), a
 ld b, c
 call ionRandom						;zweite Zufallszahl
 ld (Zahl2), a
 xor a
 ld (Zahl1+1), a
 ld (Zahl2+1), a
 ret
 
;________________________________________________________________________________________________
Unterstrich:	;(zeichnet horizontale Linie. Eingabe: bc=256*X1+Y; d=X2. Zerstrt: de,hl)
 ld e,c
 ld h,1
 bcall(_iLine)
 ret
;________________________________________________________________________________________________
Verz:	;(Eingabe: hl= Dauer der Verzgerung. Zerstrt: f, hl, de)
 ld (VZWort), hl
VSchleife:
 ld de, 1
 ld hl, (VZWort)
 sbc hl, de
 ld (VZWort), hl
 ex (SP),ix
 ex (SP),ix							;zustzliche Verzgerung
 jr nz, VSchleife
 ret
 

;_______________________________________________________________________________________________
;_____________Statische Variablen:___________________________________________________________________
;_______________________________________________________________________________________________

;___1. Zahlen:
Codes:   
 .db sk0,sk1,sk2,sk3,sk4,sk5,sk6,sk7,sk8,sk9
Tasten:
 .db skMath,skMatrix,skPrgm,skX1,skSin,skCos,skTan,skHoch,skX2,skKomma,skKlauf,skKlzu,skDiv
 .db skLog,sk7,sk8,sk9,skMult,skLn,sk4,sk5,sk6,skSub,skSto,sk1,sk2

;Highscores:
		;3	   2	      1				<- Namen ->
HA:
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
HB:
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
HC:
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
HD:
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
HE:
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
 .dw HMax,0,0,0,0, HMax,0,0,0,0, HMax, 0,0,0,0
HEnde:

;___2. Stringarrays:
SASplash:
 .db 3
 .dw 256*16+24,SGTrain,256*46+28,SVersion,256*56+18,SAutor
SAHMenu:
 .db 7
 .dw 256*4+27,SWaehlen,256*15+19,SA,256*22+19,SB,256*29+22,SC
 .dw 256*36+27,SD,256*43+37,SE,256*54+30,SAlpha
SAHilfeABC:
 .db 7
 .dw 256*6+12,SHA1,256*12+12,SHA2,256*18+12,SHA3
 .dw 256*30+12,SHA4,256*36+12,SHA5,256*42+12,SHMode
 .dw 256*48+12,SHDel
SAHilfeD:
 .db 6
 .dw 256*6+12,SHD1,256*12+12,SHD2,256*18+12,SHD3
 .dw 256*24+12,SHD4,256*36+12,SHMode,256*42+12,SHDel
SAHilfeE:
 .db 6
 .dw 256*6+12,SHE1,256*12+12,SHE2,256*24+12,SHE3
 .dw 256*31+12,SHE4,256*37+12,SHMode,256*43+12,SHDel
SAEnde:
 .db 3
 .dw 256*10+38,SAuswertung,256*23+24,SZeit,256*33+34,SFehler
SATexteingabe:
 .db 4
 .dw 256*10+17,SSiesind,256*17+38,SPlatz,256*27+29,SName
 .dw 256*46+28,SAlpha
;___3. Strings:
SGTrain
 .db "Brain Training",0
SAutor:
 .db "2009 David Kulicke",0
SVersion:
 .db "Version 1.0",0
SWaehlen:
 .db "Select Game:",0
SA:
 .db "Calculations easy", 0
SB:
 .db "Calculations hard", 0
SC:
 .db "Squares & roots",0
SD:
 .db "Reaction test",0
SE:
 .db "D",12h," test",0
SQZahl:
 .db 12h, "=",0
SAufgZahl:
 .db "Number of tasks?",0
SUngueltig:
 .db "> 5:00",0
SBereit:
 .db "Ready?",0
SZeit:
 .db "Time:",0
SFehler:
 .db "mistakes ",09h," 10s",0
SAuswertung:
 .db "Result",0
SSiesind:
 .db "You",27h,"ve reached the",0
SPlatz:
 .db ". rank!",0
SName:
 .db "Your name?",0
SAlpha:
 .db "Alpha:",0
SHilfe:
 .db " Help",0
SBListe:
 .db "Highscores",0
SHA1:
 .db "Enter the solution",0
SHA2:
 .db "of the task with",0
SHA3:
 .db "the num keys.",0
SHA4:
 .db "2nd: Confirm",0
SHA5:
 .db "Clear: Clear number",0
SHD1:
 .db "Push a num key",0
SHD2:
 .db "depending on the ",0
SHD3:
 .db "position of the circle.",0
SHD4
 .db "Ex: 1 = bottom left",0
SHE1:
 .db "Mark every D which",0
SHE2:
 .db "has two dots.",0
SHE3:
 .db "Alpha: Mark",0
SHE4:
 .db "2nd: Next letter",0
SHMode:
 .db "Mode: Pause",0
SHDel:
 .db "Del: End",0
;___4. Sprites
PRichtig:
 .db %00000001
 .db %00000011
 .db %00000110
 .db %00001100
 .db %10011000
 .db %11110000
 .db %11100000
 .db %01000000
 
PFalsch:
 .db %01100011
 .db %01100111
 .db %01111110
 .db %00111100
 .db %00111110
 .db %01110111
 .db %11100011
 .db %11000000
 
PRahmen:
 .db %00011000
 .db %00011000
 .db %00011000
 .db %11111111
 .db %11111111
 .db %00011000
 .db %00011000
 .db %00011000
 
PBalken:
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 .db %00000001
 
PAnfang:
 .db %01111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %01111111
 
PEnde:
 .db %11111110
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111110
 
P3:
 .db %00000011,%11000000
 .db %00001100,%00110000
 .db %00010000,%00001000
 .db %00100000,%00000100
 .db %01000000,%00000010
 .db %01000000,%00000010
 .db %10000000,%00000001
 .db %10000000,%00000001
 .db %10000000,%00000001
 .db %10000000,%00000001
 .db %01000000,%00000010
 .db %01000000,%00000010
 .db %00100000,%00000100
 .db %00010000,%00001000
 .db %00001100,%00110000
 .db %00000011,%11000000
 
P2:
 .db %11000000
 .db %11110000
 .db %11111000
 .db %11111100
 .db %11111100
 .db %11111110
 .db %11111110
 .db %01111110
 .db %00111110
 .db %00011100
 .db %00001100
 
P1:
 .db %00001000,%00000000
 .db %00011100,%00000000
 .db %00111110,%00000000
 .db %01111111,%00000000
 .db %11111111,%10000000
 .db %11111111,%11000000
 .db %01111111,%10000000
 .db %00011110,%00000000
	
P0:
 .db %00000110
 .db %00011110
 .db %00111110
 .db %01111110
 .db %01111110
 .db %11111110
 .db %11111100
 .db %11111000
 .db %11110000
 .db %01100000
 .db %01000000
 
PBlink:
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 .db %11111111,%11111111,%11111110
 
PShiftOff:
 .db %01111111,%11111000
 .db %10000000,%00000100
 .db %10000011,%00000100
 .db %10000111,%10000100
 .db %10001111,%11000100
 .db %10000111,%10000100
 .db %10000111,%10000100
 .db %01111111,%11111000
 
PShiftOn:
 .db %01111111,%11111000
 .db %11111111,%11111100
 .db %11111100,%11111100
 .db %11111000,%01111100
 .db %11110000,%00111100
 .db %11111000,%01111100
 .db %11111000,%01111100
 .db %01111111,%11111000
 
PZiel:
 .db %00111100
 .db %01111110
 .db %11111111
 .db %11111111
 .db %11111111
 .db %11111111
 .db %01111110
 .db %00111100
 
PZweiPunkte:
 .db %01100110
 .db %01100110

PEinPunkt:
 .db %00011000
 .db %00011000
 
PBuchD:
 .db %00000110
 .db %00000110
 .db %00000110
 .db %00111110
 .db %01111110
 .db %01100110
 .db %01100110
 .db %01111110
 .db %00111110
 
PBuchB:
 .db %01100000
 .db %01100000
 .db %01100000
 .db %01111100
 .db %01111110
 .db %01100110
 .db %01100110
 .db %01111110
 .db %01111100
	
PBuchP:
 .db %01111100
 .db %01111110
 .db %01100110
 .db %01100110
 .db %01111110
 .db %01111100
 .db %01100000
 .db %01100000
 .db %01100000
 
PBuchQ:
 .db %00111110
 .db %01111110
 .db %01100110
 .db %01100110
 .db %01111110
 .db %00111110
 .db %00000110
 .db %00000110
 .db %00000110
 
PCheckbox:
 .db %11111110
 .db %10000010
 .db %10000010
 .db %10000010
 .db %10000010
 .db %10000010
 .db %11111110
 
PJa:
 .db %00111000
 .db %00111000
 .db %00111000
 
PNein:
 .db %00101000
 .db %00010000
 .db %00101000
 
PGehirn:
 .db %00000000,%00011111,%11100000,%00000000
 .db %00000000,%01100101,%00111110,%00000000
 .db %00000001,%11111000,%00010111,%10000000
 .db %00000011,%10001010,%00110000,%01000000
 .db %00001101,%10011010,%01011100,%01110000
 .db %00010110,%10101010,%11000101,%10010000
 .db %00101100,%10110010,%10010100,%11101000
 .db %00110000,%10100011,%00110100,%00010100
 .db %01000000,%11001100,%00010000,%10001110
 .db %01110001,%11011100,%11111001,%00101110
 .db %11111111,%01101111,%00010010,%00001011
 .db %10101011,%00001100,%00010110,%01010101
 .db %11000100,%01010100,%10011101,%11111111
 .db %10111100,%11100110,%11100000,%01000011
 .db %11100010,%01001100,%11110111,%00011011
 .db %11111111,%10010000,%10010011,%00010111
 .db %01111111,%01110011,%10111111,%11111110
 .db %00111111,%01001001,%11001110,%00000000
 .db %00011111,%00110010,%11010000,%00000000
 .db %00000001,%00011101,%10000000,%00000000
 .db %00000000,%10111011,%00000000,%00000000
 .db %00000000,%01111100,%00000000,%00000000
 
PSchrift:
 .db %00000011,%11101100,%00000110,%01100000,%11000000,%00011100,%00011011
 .db %00000110,%00011111,%10001100,%11000001,%11000110,%00110110,%00110110
 .db %00001100,%00011001,%10001100,%11000011,%11001100,%01100110,%01110110
 .db %00001111,%00011001,%10011001,%10000111,%10001100,%01100110,%11110110
 .db %00011100,%00011011,%00110001,%11001101,%10011000,%11001101,%10111100
 .db %00111000,%00111110,%00111111,%00011111,%11110001,%10001101,%10111100
 .db %00110000,%00111000,%11110110,%00111001,%10110001,%10011011,%00111000
 .db %01100000,%01100000,%01100110,%11110001,%11100011,%00011011,%00111000
 .db %01100000,%01100000,%01100110,%01100011,%01100011,%00110011,%00111000
 .db %11111110,%11000000,%11001100,%01100011,%11111011,%01100110,%00110000
 .db %11100000,%11000000,%11001100,%11000011,%11100011,%11000110,%00110000
;__________________________________________________________________________________________________________
.end
.END